Subject: bug#64061: 30.0.50; auto-revert-mode is not working for files with symlinked directories in path

From: Michael Albinus <[email-masked]>
Date: Fri, 16 Jun 2023 10:17:06 +0200

Eli Zaretskii <[email-masked]> writes:

Hi,

>> cd /tmp/
>> mkdir foo
>> ln -s foo bar
>> touch bar/test.txt
>> emacs bar/test.txt &
>> in emacs: M-x auto-revert-mode RET
>> then in bash
>> echo "test001" >> bar/test.txt
>>
>> Emacs will never see those changes and will not revert the buffer.
>> However, opening foo/text.txt does not have this problem.
>>
>> I tried inotifywait -m on both foo/text.txt, and on bar/text.txt, and
>> both seem to receive editing events as they should.
>
> Emacs watches the directory of the file, not the file itself.  Does
> inotify report events when you watch the directory of that file?  Does
> auto-revert-mode work for that file if you disable
> auto-revert-use-notify?
>
> I'm guessing inotify doesn't report such directories, or reports them
> under a name we don't recognize, which would mean that we need another
> condition for not activating file-watch for files whose directory is a
> symlink.

This is a duplicate of bug#16113 and bug#18883, I've merged them with
this bug. I'll see whether I could work on this next time (matter of time).

Best regards, Michael.